#include <c6x_vec.h>

inline void VecMultVec(float const *x, float const *y, float *z, int len )
{
   int n;
   float16 *v1, *v2, *v3;

   v1 = (float16*)x;
   v2 = (float16*)y;
   v3 = (float16*)z;

   len >>= 4;

   #pragma MUST_ITERATE(1,,)
   for(n = 0; n < len; n++)
        *v3++ = *v1++ * *v2++;
}

void VecMultVec2(float const *x, float const *y, float *z, int len )
{
   int n;
   float16 *v1, *v2, *v3;

   v1 = (float16*)x;
   v2 = (float16*)y;
   v3 = (float16*)z;

   len >>= 4;

   #pragma MUST_ITERATE(1,,)
   for(n = 0; n < len; n++)
        *v3++ = *v1++ * *v2++;
}

inline void VecMultVec3(float const *x, float const *y, float *z, int len )
{
   int n;
   float16 *v1, *v2, *v3;

   v1 = (float16*)x;
   v2 = (float16*)y;
   v3 = (float16*)z;

   len >>= 4;

   #pragma MUST_ITERATE(1,,)
   for(n = 0; n < len; n++)
        v3[n] = v1[n] * v2[n];
}

inline void VecMultVec4(float const *x, float const *y, float *z, int len )
{
   int n;
   float16 *v1, *v2, *v3;

   v1 = (float16*)x;
   v2 = (float16*)y;
   v3 = (float16*)z;

   len >>= 4;

   #pragma MUST_ITERATE(1,,)
   for(n = 0; n < len; n++)
   {
       //*(v3++) = (*(v1++)) * (*(v2++));
	   *v3 = *v1 * *v2;
	   v1++;
	   v2++;
	   v3++;
   }
}


int main()
{
	float x[16] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16};
    float z[16] = {};	
    
    VecMultVec(x, x, z, 16);
    VecMultVec2(x, x, z, 16);
    VecMultVec3(x, x, z, 16);
    VecMultVec4(x, x, z, 16);
	
	return 0;
}
